Skip to content

Commit

Permalink
Merge pull request kubernetes-retired#485 from gitvinit/ci-format
Browse files Browse the repository at this point in the history
Adds gofmt verification
  • Loading branch information
k8s-ci-robot authored Apr 19, 2023
2 parents 6a7557a + 08a3d75 commit 48b7bca
Show file tree
Hide file tree
Showing 4 changed files with 129 additions and 1 deletion.
30 changes: 30 additions & 0 deletions .github/workflows/vet-code.yml
Original file line number Diff line number Diff line change
@@ -0,0 +1,30 @@
name: Code format verify

on:
push:
branches:
- master
pull_request:
branches:
— master

jobs:
gofmt:
name: Run gofmt verify
runs-on: ubuntu-latest
steps:
- name: Setup Go
uses: actions/setup-go@v2
with:
go-version: '1.19'
stable: 'false'

- name: Install dependencies
run: |
go version
go install golang.org/x/lint/golint@latest
- name: checkout
uses: actions/checkout@v2

- name: run gofmt tests
run: ./hack/verify-gofmt.sh
3 changes: 2 additions & 1 deletion hack/README.md
Original file line number Diff line number Diff line change
Expand Up @@ -149,7 +149,8 @@ pushing directly to a local registry and configuring kind to use this reg, so do
isnt required.
- Or a `tilt` recipe which hot reloads all kpng on code changes.


## Code formating
**We should run `hack/verify-gofmt.sh` before submitting a PR it checks whether the source code needs to be formatted or not and if anything fails run `hack/update-gofmt.sh` to actually format sources**.



Expand Down
40 changes: 40 additions & 0 deletions hack/update-gofmt.sh
Original file line number Diff line number Diff line change
@@ -0,0 +1,40 @@
#!/usr/bin/env bash

# Copyright 2023 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# GoFmt apparently is changing @ head...

set -o errexit
set -o nounset
set -o pipefail

ROOT=$(dirname "${BASH_SOURCE[0]}")/..

cd "${ROOT}"

function git_find() {
# Similar to find but faster and easier to understand. We want to include
# modified and untracked files because this might be running against code
# which is not tracked by git yet.
git ls-files -cmo --exclude-standard \
':!:vendor/*' `# catches vendor/...` \
':!:*/vendor/*' `# catches any subdir/vendor/...` \
':!:third_party/*' `# catches third_party/...` \
':!:*/third_party/*' `# catches third_party/...` \
':(glob)**/*.go' \
"$@"
}

git_find -z | xargs -0 gofmt -s -w
57 changes: 57 additions & 0 deletions hack/verify-gofmt.sh
Original file line number Diff line number Diff line change
@@ -0,0 +1,57 @@
#!/usr/bin/env bash

# Copyright 2023 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# This script checks whether the source code needs to be formatted or not by
# `gofmt`. Run `hack/update-gofmt.sh` to actually format sources.
#
# Note: gofmt output can change between go versions.
#
# Usage: `hack/verify-gofmt.sh`.

set -o errexit
set -o nounset
set -o pipefail

ROOT=$(dirname "${BASH_SOURCE[0]}")/..

cd "${ROOT}"

find_files() {
find . -not \( \
\( \
-wholename './output' \
-o -wholename './.git' \
-o -wholename './_output' \
-o -wholename './_gopath' \
-o -wholename './release' \
-o -wholename './target' \
-o -wholename '*/third_party/*' \
-o -wholename '*/vendor/*' \
\) -prune \
\) -name '*.go'
}

# gofmt exits with non-zero exit code if it finds a problem unrelated to
# formatting (e.g., a file does not parse correctly). Without "|| true" this
# would have led to no useful error message from gofmt, because the script would
# have failed before getting to the "echo" in the block below.
diff=$(find_files | xargs gofmt -d -s 2>&1) || true
if [[ -n "${diff}" ]]; then
echo "${diff}" >&2
echo >&2
echo "Lint issues found, run ./hack/update-gofmt.sh to fix." >&2
exit 1
fi

0 comments on commit 48b7bca

Please sign in to comment.